[leetcode]Two Sum

问题描写叙述:

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

基本思路:

O(n2) runtime, O(1) space – Brute force:

The brute force approach is simple. Loop through each element x and find if there is another value that equals to target – x. As finding another value requires looping through the rest of array, its runtime complexity is O(n2).

O(n) runtime, O(n) space – Hash table:

We could reduce the runtime complexity of looking up a value to O(1) using a hash map that maps a value to its index.

代码:

vector<int> twoSum(vector<int> &numbers, int target) {
        
        //consider the same num;
        vector<int> result; 
        map<int,int> num_pos;
        map<int,int>::iterator iter;
        for(int i = 0; i < numbers.size(); i++){
            int diff = target - numbers[i];
            iter = num_pos.find(diff);
            if(iter != num_pos.end()){
                result.push_back(iter->second);
                result.push_back(i+1);
                break;
            }
            num_pos.insert(make_pair(numbers[i],i+1));
        }
        return result;
        
    }


posted @ 2017-04-12 12:12  zhchoutai  阅读(118)  评论(0编辑  收藏  举报